
 ;**************************************************************************
 ;*                                                                        * 
 ;*               O R Z U N O I D   F O R   U S G A R D                    * 
 ;*                                                                        * 
 ;*     Copyright 1997-1999 by Patrick Davidson.  All Rights Reserved.     * 
 ;*                                                                        * 
 ;*                    Last Updated : February 2, 1998                     * 
 ;*                                                                        * 
 ;*                                                                        * 
 ;*                        COPYRIGHT CONDITIONS:                           * 
 ;*                                                                        * 
 ;*  GENERAL:  This game is copyrighted but freely redistributable.  This  * 
 ;*  means that you can copy it as much as you want to, free of charge.    * 
 ;*  are distributing it between computers you should include the          * 
 ;*  documentation with it.  If you are distributing it to or between      * 
 ;*  calculators, only the executable needs to be sent.                    * 
 ;*                                                                        * 
 ;*  MODIFICATION:  If you wish to make a modified version of this game,   * 
 ;*  you may do so if and only if the following four conditions are met:   * 
 ;*                                                                        * 
 ;*  1) These copyright conditions must also cover the new version.        * 
 ;*  2) All authorship and contact information, in the documentation,      * 
 ;*     executable, and source code must reamin in the new version.        * 
 ;*     You may add to such information but must not remove or change any  * 
 ;*     of it.                                                             * 
 ;*  3) The executable, documentation, and source code must identify that  * 
 ;*     it is a modified version of Phoenix.                               * 
 ;*  4) The source code of the new version must be available.              * 
 ;*                                                                        *
 ;*  EXTRACTING ROUTINES:  If you want to extract code from this game to   *
 ;*  use in your own programs, the conditions vary depending on the total  *
 ;*  number of lines (in original or modified form) that you copy.  The    *
 ;*  requirements are listed in the table below:                           *
 ;*                                                                        *
 ;*  1 to 63 lines - The original author must be identified in your        *
 ;*                  source code (so people looking at your source know    *
 ;*                  where it came from, and also so you'll be sure just   *
 ;*                  how much you copied).                                 *
 ;*  64 to 255 lines - The original author must be given credit on the on  *
 ;*                    the title screen of your program, in addition to    *
 ;*                    the source requirement above.                       *
 ;*  256 or more lines - If you copy this much code, your program must be  *
 ;*                      considered to be a modified version of the game.  *
 ;*                      (see the MODIFICATION section for rules)          *
 ;*                                                                        * 
 ;*  DISCLAIMER:  This software is supplied "as is" with no warranty of    * 
 ;*  any kind!  It has been tested and found to work as intended and not   * 
 ;*  to destroy data on the calculator.  However, there is still a         * 
 ;*  possibility of unexpected problems with this game, so there cannot    * 
 ;*  be any guarantees regarding it.  It is possible that it will          *  
 ;*  malfunction and cause a loss of data on the calculator.  In any       * 
 ;*  case, you are using this software at your own risk, and any problems  * 
 ;*  it may cause are your responsibility!                                 * 
 ;*                                                                        * 
 ;*                                                                        * 
 ;*                          CONTACT ADDRESSES                             * 
 ;*                                                                        * 
 ;*     WWW : http://surf.to/eeulplek/                                     * 
 ;*           http://www.calweb.com/~kwdavids/patrick/                     * 
 ;*                                                                        * 
 ;*  E-Mail : luezma@netscape.net            <----- the preferred address  * 
 ;*           ariwsi@rockemtail.com                                        * 
 ;*           eeulplek@webmail.bellsouth.net                               * 
 ;*           axeeodyx@easley.net                                          * 
 ;*                                                                        * 
 ;************************************************************************** 

         .org     0
         .include "usgard.h"
         .include "orzunoid.h"
         .db      "Orzunoid 6.4 by Patrick D"
         .db      0

 ; ************** System Initialization ***********************************

         ld       a,(CONTRAST)               ;Increase contrast by 2

         add      a,2
         bit      5,a
         jr       z,cok
         ld       a,$1f
cok:     out      (2),a

         ld       (contrst),a
         ld       (iy+13),0

         ld       hl,TEXT_MEM                ;clear text memory
         ld       bc,160
         call     OTH_CLEAR

         ld       hl,DELC_LEN                ;clear DELc memory
         ld       bc,100
         call     OTH_CLEAR

 ; ************** Load Orzunoid Version and Definition Tables *************

         ld       hl,&orz_data               
         ld       de,TEXT_MEM2+14
         ld       bc,152
         ldir

 ; ************** Display Title Screen ************************************

         ld       hl,(TEXT_MEM2+166)         ;See if this is "2nd pass"
         ld       de,52682                   ;loading from external levels
         call     CP_HL_DE
         jr       z,restore_new_entry_point

         call     CLEARLCD
         ld       hl,$0401                   ;Display title
         ld       ($800c),hl
         ld       hl,&title_message
         call     D_ZT_STR

         ld       de,$FC20                   ;Slide title up
         ld       hl,$FC80
         ld       bc,$300
         ldir

         ld       b,28
         call     &lines_sides

         ld       a,0                        ;Draw lines across screen
         call     &horiz_line
         ld       a,27
         call     &horiz_line

 ; ************** Restore Saved Game ************************************** 

         ld       hl,&saved_flag             ;Test for saved game
         ld       a,(hl)
         or       a
         jp       z,&no_saved_game
         ld       (hl),0                     ;Clear saved game flag

         ld       hl,CURSOR_ROW              ;Ask whether to restore game
         ld       (hl),5
         ld       hl,&saved_message
         call     D_ZT_STR
restore_q_loop:
         call     GET_KEY                    ;Read keystroke
         cp       K_F5                       ;F5 = don't restore
         jp       z,&start_new_game
         cp       K_EXIT
         jr       z,goto_exit_game_2
         cp       K_F1                       ;F1 = restore
         jr       nz,restore_q_loop

         ld       a,(&universe_id)           ;Test if built-in universe
         or       a
         jr       z,built_in_universe

         ld       hl,52682                   ;Signal back to Orzunoid
         ld       de,(u_signature_52682)
         call     CP_HL_DE
         jr       z,restore_new_entry_point
         ld       (TEXT_MEM2+166),hl
         ld       hl,&universe_id            ;Execute universe
         call     VAR_EXEC                   
         ret      nc

loading_error:                               ;Failed to load universe
         call     CLEARLCD
         ld       ($800c),de
         ld       hl,&restore_error
         call     D_ZT_STR
         call     OTH_PAUSE
goto_exit_game_2:
         jp       &exit_game_2

restore_new_entry_point:
         ld       hl,0                       ;Clear signal to Orzunoid
         ld       (TEXT_MEM2+166),hl
         ld       hl,(u_signature_52682)     ;Test universe loading
         call     CP_HL_DE
         jr       nz,loading_error

         ld       hl,&universe_id            ;Test universe name
         ld       de,u_name
loop_name_test:
         ld       b,(hl)
         ld       a,(de)
         cp       b
         jr       nz,loading_error
         inc      hl
         inc      de
         or       a
         jr       nz,loop_name_test

         call     &set_up_universe           ;Set up the universe

built_in_universe:
         ld       hl,&saved_flag+1           ;Restore data
         ld       de,TEXT_MEM+1
         ld       bc,160
         ldir
         ld       de,DELC_LEN+21
         ld       bc,80
         ldir

         call     __init_display             ;Initialize display
         call     __update_display           ;Show data
         call     __resume_game              ;Play the game
         jr       game_over

 ; ************** Start a New Game ****************************************

no_saved_game:
         ld       hl,CURSOR_ROW              ;Display "Press ENTER" message
         ld       (hl),7
         ld       hl,&enter_message
         call     D_ZT_STR
         ld       hl,$2318
         ld       (CURSOR_X),hl
         ld       hl,&contact_messages
         call     D_ZM_STR
         ld       de,$2a14
         ld       (CURSOR_X),de
         call     D_ZM_STR

loop_title:
         call     GET_KEY                   
         cp       K_EXIT
         jr       z,goto_exit_game_2
         cp       K_ALPHA
         jp       z,&display_high_scores
         cp       K_ENTER
         jr       nz,loop_title

start_new_game:
         ld       hl,(u_signature_52682)     ;Test for external universe
         ld       de,52682
         call     CP_HL_DE
         jr       nz,no_external_universe

         call     &set_up_universe           ;Reloc & initialize universe

         jr       play_the_game

no_external_universe:
         ld       hl,&universe_id            ;Clear out universe ID
         ld       bc,9
         call     OTH_CLEAR

play_the_game:         
         call     __title_screen
         call     __start_game               ;Play the game!!!

 ; *************** Game-Over Routine **************************************

game_over:                                   ; Set up score page
         ld       hl,(&lowest)               ; See if ya got a hi-score
         ld       de,(score)
         call     CP_HL_DE
         jp       nc,&display_high_scores
         call     CLEARLCD 
         ld       ($800c),de
         ld       hl,&hi_score_str
         call     D_ZT_STR)
         ld       hl,&lowest+2
         ld       (temp),hl
         ld       b,16
space_loop:
         ld       (hl),32
         inc      hl
         djnz     space_loop
         ld       ix,(temp)
         ld       b,0
enter_name_loop:
         call     GET_KEY
         or       a
         jr       z,enter_name_loop
         cp       K_DEL
         jr       z,backup
         cp       K_ENTER
         jr       z,nomore
         ld       c,a
         ld       a,15
         cp       b
         jr       z,enter_name_loop
         ld       hl,&chartable-10
         ld       e,c
         ld       d,0
         add      hl,de
         ld       a,(hl)
         ld       (ix),a     
         call     TX_CHARPUT) 
         inc      b
         inc      ix
         jr       enter_name_loop
backup:  dec      b
         ld       a,255
         cp       b
         jr       z,too_far
         dec      ix
         ld       (ix),32
         ld       hl,CURSOR_COL
         dec      (hl)
         ld       a,32
         call     TX_CHARPUT 
         dec      (hl)
         jr       enter_name_loop
too_far: inc      b
         jr       enter_name_loop
nomore:
         ld       hl,&lowest
         ld       de,(score)
         ld       (hl),e
         push     hl
         inc      hl
         ld       (hl),d
         pop      ix                         ;sort hiscore table
         ld       b,6
sort_scores
         ld       e,(ix)
         ld       d,(ix+1)
         ld       l,(ix-19)
         ld       h,(ix-18)
         call     CP_HL_DE
         jr       nc,display_high_scores
         push     bc
         ld       b,19
         ld       d,0
exg_loop:ld       e,(ix)
         ld       c,(ix-19)
         ld       (ix),c
         ld       (ix-19),e
         inc      ix
         inc      hl
         djnz     exg_loop
         ld       de,-38
         add      ix,de
         pop      bc
         djnz     sort_scores

 ; ************** Display High Scores *************************************

display_high_scores:
         call     CLEARLCD
         ld       ($800c),de
         ld       hl,&hstitle
         call     D_ZT_STR)
         ld       a,16
         ld       (CURSOR_COL),a

         ld       de,&hsdata
         ld       b,7
high_display_loop:                           ;Display high scores
         ld       a,(de)
         ld       l,a
         inc      de
         ld       a,(de)
         ld       h,a
         inc      de
         push     de
         call     D_HL_DECI 
         ld       hl,CURSOR_ROW
         dec      (hl)
         pop      hl
         call     D_ZT_STR 
         ex       de,hl
         ld       hl,CURSOR_ROW
         inc      (hl)
         djnz     high_display_loop

         call     &wait_key
         jp       __exit_game

 ; ************** Exit The Game *******************************************

exit_game:                                 
         ld       hl,&universe_id            ;Test for external universe
         ld       a,(hl)
         or       a
         call     nz,DERELOC                 ;If present, de-relocate it

exit_game_2:
         ld       a,(CONTRAST)               ;Restore contrast
         out      (2),a

         ld       a,3                        ;"Warp" out, recalc checksum
         ld       (USG_BITS),a

         ld       hl,DELC_LEN                ;Clear temporary memory
         ld       bc,100
         call     OTH_CLEAR
         ld       hl,TEXT_MEM2
         ld       bc,167
         ld       (hl),' '
         call     OTH_FILL

         set      0,(iy+3)                   ;Make graph redraw
         jp       OTH_EXIT                   ;Finally exit

 ; ************** Relocate and initialize universe ************************

set_up_universe:
         ld       hl,u_name                  ;Relocate the universe
         call     RELOC

         ld       hl,u_name                  ;Save universe name
         ld       de,&universe_id
         ld       bc,10
         ldir

         ld       hl,(u_call)                ;Set up external universe
         ld       (&smccall+1),hl
smccall:
         call     $0000
         ld       hl,0
         ld       (u_signature_52682),hl
         ld       hl,&hexedit_
         jp       VAR_EXEC     

hexedit_:
         .db      "X",0

 ; ************** Default Title Screen ************************************

title_screen:
         call     CLEARLCD

         ld       b,64
         call     &lines_sides

         ld       hl,$0401                   ;Write "Instructions:" message
         ld       (CURSOR_ROW),hl
         ld       hl,&title_screen_inst
         call     D_ZT_STR
         ld       de,$FC30                   ;Slide message up 5 lines
         ld       hl,$FC80
         ld       bc,$100
         ldir

         ld       a,0                        ;Draw lines across screen
         call     &horiz_line
         ld       a,13
         call     &horiz_line
         ld       a,46
         call     &horiz_line
         ld       a,63
         call     &horiz_line

         ld       hl,$3004
         ld       (CURSOR_X),hl
         ld       hl,&instructions_text
         call     D_ZM_STR
         ld       de,$3704
         ld       (CURSOR_X),de
         call     D_ZM_STR
         ld       de,$1004
         ld       (CURSOR_X),de
         call     D_ZM_STR
         ld       de,$1709
         ld       (CURSOR_X),de
         call     D_ZM_STR
         ld       de,$1E03
         ld       (CURSOR_X),de
         call     D_ZM_STR
         ld       de,$2503
         ld       (CURSOR_X),de
         call     D_ZM_STR

title_loop:
         call     GET_KEY

         cp       K_ALPHA
         jp       z,&display_high_scores
         cp       K_EXIT
         jp       z,__exit_game
         sub      $31
         jp       m,&title_loop
         cp       5
         ret      m
         jr       title_loop

 ; ************** Default Game Routines ***********************************

start_game:
         ld       hl,speed
         ld       (hl),a
         ld       a,5
         sub      (hl)
         rlca
         rlca
         rlca
         rlca
         rlca
         and      %11100000
         ld       (score),a
         ld       hl,lives
         ld       (hl),3
         dec      hl
         dec      hl
         ld       (hl),5

         call     &un_expand
         ld       hl,500
         ld       (&lgain2+1),hl

 ; ************** Outer Game Loop *****************************************

         call     __init_display
play_da_game:

         ld       hl,&lives
         inc      (hl)
         ld       a,(level)
         call     __extract_level
         ld       hl,level
         inc      (hl)
level_loop:   
         call     __prepare_level
resume_game:
         call     __play_level
         xor      a
         out      (1),a
         ld       a,(won)
         or       a
         jr       z,finished_level
         ld       hl,lives
         dec      (hl)
         ret      z
         jr       level_loop
finished_level:
         call     __level_win

         ld       a,(num_levels)
         ld       d,a
         ld       a,(level)
         cp       d
         jp       nz,&play_da_game
         jp       __game_win

 ; ************** Add Points When You Win The Game ************************

game_win:
         ld       a,(lives)
         ld       b,a
lgain2:  ld       de,500
         ld       hl,(score)
         add      hl,de
         ld       (score),hl
         push     bc
         call     __update_display
         pop      bc
         djnz     lgain2
         ret

 ; ************** Add Points When You Win a Level *************************

level_win:
         ld       b,0
         ld       a,(x+3)
         or       a
         jr       z,n1
         inc      b
n1:      ld       a,(x2+3)
         or       a
         jr       z,n2
         inc      b
n2:      ld       a,(x3+3)
         or       a
         jr       z,n3
         inc      b
n3:      ld       a,b
         add      a,a
         add      a,a
         add      a,a
         add      a,a
gp:      ld       hl,(score)
         ld       de,2
         add      hl,de
         ld       (score),hl
         push     af
         call     __update_display
         pop      af
         dec      a
         jr       nz,gp
         ret

 ; ************** Prepare a Level *****************************************

prepare_level:
         ld       hl,p
         ld       (hl),112
         inc      hl
         ld       (hl),128
         inc      hl
         ld       (hl),-1
         inc      hl
         ld       (hl),50
         inc      hl
         ld       (hl),-1
         inc      hl
         xor      a
         ld       (hl),a
         ld       de,x2+1
         ld       bc,7
         ldir
         ld       (guard),a
         ld       (bthru),a
         call     &un_expand
         ret

 ; ************** Load level data to $8100 ********************************

extract_level:
         ld       hl,&universe-32
         ld       b,a
         inc      b
         ld       de,32
find_level_loop:
         add      hl,de
         djnz     find_level_loop

levels_loaded_into_delc:
         ld       b,32                       ;Copy the map
         ld       de,data
set_up_1:
         push     bc
         ld       b,4
         ld       c,(hl)
loop_row:
         rlc      c
         rlc      c
         ld       a,c
         and      3
         ld       (de),a
         inc      de
         djnz     loop_row
         inc      hl
         pop      bc
         djnz     set_up_1
         ret

 ;*************** Game Main Loop ******************************************

play_level:
         ld       a,1                        ; Level should begin paused
         ld       (stop),a
game_main_loop:

         call     __draw_level               ; Draw the level's bricks

         ld       a,(speed)                  ; Slow down
         or       a
         call     nz,&waste_time

         ld       hl,(timer)                 ; Update timer
         inc      hl
         ld       (timer),hl

         xor      a                          ; Process balls sequentially
         ld       (aball),a
         ld       hl,x
         ld       b,3
ldb:     push     hl
         push     bc
         call     __ballstuff
         pop      bc
         pop      hl
         ld       de,4
         add      hl,de
         djnz     ldb

         ld       a,(aball)                  ; Lose if out of balls
         or       a
         ret      z

         ld       a,%01111110                ; Read keyboard
         out      (1),a
         in       a,(1)

         rrca                                ; Save if down arrow pressed
         jr       c,no_save
         ld       hl,&saved_flag
         ld       (hl),1
         ld       de,&saved_flag+1
         ld       hl,TEXT_MEM+1
         ld       bc,160
         ldir
         ld       hl,DELC_LEN+31
         ld       bc,80
         ldir
         jp       __exit_game
no_save:
         call     __paddle_move

         call     __bonus_blocks             ; Handle bonus blocks

         call     __display_screen           ; Display the screen 

         call     __update_display           ; Update data display

         ld       a,(stop)                   ; Go into pause mode if paused
         or       a
         call     nz,&stopped

         call     GET_KEY                    ; Handle EXIT/PAUSE keys
         cp       K_EXIT
         jp       z,__exit_game
         cp       K_CLEAR
         ret      z
         cp       K_ENTER
         call     z,&stopped

         ld       a,(won)                    ; Continue unless player won
         or       a
         jr       nz,game_main_loop
         ret

 ; ************** Game Is Paused ******************************************

stopped: SUB      A                          ; Remove paused flag
         ld       (stop),a

         ld       hl,$290f
         ld       (CURSOR_X),hl
         ld       hl,&paused_msg
         call     D_ZM_STR)
         ld       de,$3009
         ld       (CURSOR_X),de
         call     D_ZM_STR

wenter:  call     GET_KEY
         ld       hl,contrst
         cp       K_ENTER
         ret      z
         cp       K_PLUS
         jr       nz,nic
         ld       a,(hl)
         cp       $1f
         jr       z,wenter
         inc      a
         jr       cc_common
nic:     cp       K_MINUS
         jr       nz,wenter
         ld       a,(hl)
         or       a
         jr       z,wenter
         dec      a
cc_common:
         ld       (hl),a
         out      (2),a
         jr       wenter

 ; ************** Locate Bonus Brick Image ********************************

bonus_get_image:
         ld       e,a
         ld       d,0
         ld       hl,&bonus_image_table-2
         add      hl,de
         call     LD_HL_MHL
         ld       de,(PROGRAM_ADDR)
         add      hl,de
         push     hl
         pop      ix
         ret

bonus_image_table:
         .dw      bonus_1   
         .dw      bonus_2   
         .dw      bonus_3   
         .dw      bonus_4   
         .dw      bonus_5   
         .dw      bonus_6   
         .dw      bonus_7   

 ; ************** Bonus Bricks ********************************************

killbb:  dec      hl
         dec      hl
         ld       (hl),0
         ret

bonus_blocks:
         ld       a,(bonust)
         add      a,a
         ret      z
         call     __bonus_get_image

         ld       hl,bonusx
         LD       D,(hl)
         srl      d
         inc      hl
         ld       e,(HL)
         call     &drw_sprw
         ld       hl,bonusy
         ld       a,(timer)
         and      1
         add      a,(hl)
         ld       (hl),a
         ld       a,(hl)
         cp       56
         jr       z,killbb
         cp       50
         ret      m
         dec      hl
         ld       a,(p)
         neg
         add      a,(hl)
         add      a,20
         ret      m
exp1:    sub      52
         ret      p
         dec      hl
         ld       a,(hl)
         ld       (hl),0
         jp       __bonus_collect

 ; ************** Bonus Collection Handling *******************************

bonus_collect:
         dec      a
         JR       Z,got1
         dec      a
         jr       z,got2
         dec      a
         JR       Z,got3
         dec      a
         jr       z,got4
         dec      a
         jr       z,got5
         dec      a
         jr       z,got6

got7:    ld       hl,bthru
         inc      (hl)
         inc      (hl)
         jr       score25

got1:    ld       hl,lives
         inc      (hl)
         ret

got2:    ld       de,4                       ;Find first active ball
         ld       hl,x+3
         ld       a,(hl)
         or       a
         jr       nz,copyball
         add      hl,de
         ld       a,(hl)
         or       a
         jr       nz,copyball
         add      hl,de

copyball:                                    ;Exchange that into first ball
         ld       de,x+3
         ld       b,4
lcopyball:
         ld       a,(hl)
         ld       (hl),0
         ld       (de),a
         dec      hl
         dec      de
         djnz     lcopyball

         ld       a,(x2+3)                   ;Test if second ball is used
         or       a
         jr       nz,b1_no
         ld       hl,x                       ;Split into second ball if it
         ld       de,x2           
         ld       bc,4
         ldir
         ld       hl,x2+1
         inc      (hl)
b1_no:
         ld       a,(x3+3)                   ;Test if third ball is used
         or       a
         ret      nz
         ld       hl,x                       ;Split into third ball
         ld       de,x3
         ld       bc,4
         ldir
         ld       hl,x3+1
         dec      (hl)
         jr       score25

got3:
         ld       a,32
         ld       (expand),a
         ld       a,84
         ld       (&exp1+1),a
         ld       hl,$3fcb
         ld       (&exp2),hl
         ld       a,64
         ld       (p_width),a
         jr       score25

got4:    ld       de,100
         jr       score__

got5:    LD       A,255
         LD       (guard),a
         jr       score25

got6:    ld       hl,catch
         inc      (hl)
         inc      (hl)

score25: ld       de,25
score__: ld       hl,(score)
         add      hl,de
         ld       (score),hl
         ret

 ; ******************* Utility Routines ***********************************

un_expand:
         ld       a,52
         ld       (&exp1+1),a
         xor      a
         ld       hl,&exp2
         ld       (hl),a
         inc      hl
         ld       (hl),a
         ld       (expand),a
         ld       a,32
         ld       (p_width),a
         ret

wait_key:ld       a,40                       ;Wait for a keypress
         call     &waste_time
wait_inner:
         call     GET_KEY
         or       a
         ret      nz
         jr       wait_inner

waste_time:
l:       halt
         dec      a
         jr       nz,l
         ret

 ; ************** Display the game screen ********************************

display_screen:
         ld       de,$fc80
         ld       hl,GRAPH_MEM
         ld       bc,896
         ldir
         ret

 ; ************** Update data displays ************************************

nothing: ld       a,32
         jr       dispit2
update_display:                                     
         ld       hl,$800                    ;Locate cursor for lives
         ld       (CURSOR_ROW),hl
         ld       a,(olives)                 ;Test if # lives changed
         ld       b,a
         ld       a,(lives)
         cp       b
         jr       z,no_lives_change
         ld       (olives),a
         ld       l,a                        ;Display least sig. digit
         ld       h,0
         call     UNPACK_HL
         add      a,48
         push     hl
         call     TX_CHARPUT 
         ld       a,7                        ;Locate cursor for next digit
         ld       (CURSOR_COL),a
         pop      hl                         ;Display 2nd digit (if non-0)
         call     UNPACK_HL
         or       a
         jr       z,nothing
         add      a,48
dispit2: call     TX_CHARPUT 
no_lives_change:
         ld       hl,(score)                 ;Test if score change
         ld       de,(oscore)
         call     CP_HL_DE
         ld       a,$10                      ;Locate cursor for lives
         ld       (CURSOR_COL),a 
         ld       (oscore),hl
         call     nz,D_HL_DECI               ;Display lives if changed
no_score_change:
         ld       a,7                        ;Draw line over screen top

horiz_line:                                  ;Draw one horizontal line
         add      a,a
         add      a,a
         ld       l,a
         ld       a,255
         ld       h,a
         add      hl,hl
         add      hl,hl
         ld       bc,15
         ld       (hl),255
         jp       OTH_FILL

lines_sides:
         ld       hl,$fc00
         ld       de,15
loop_left_right_i:                           ;Draw lines on sides of screen
         set      7,(hl)
         add      hl,de
         set      0,(hl)
         inc      hl
         djnz     loop_left_right_i
         ret

 ; ************** Initialize In-Game display *****************************

init_display:
         call     CLEARLCD 
         ld       (CURSOR_ROW),de
         ld       hl,&ingame
         call     D_ZT_STR 
         ld       a,7
         jp       &horiz_line

 ; ************** Movement of paddle *************************************

paddle_move:
         rrca                                ; Movement of paddle
         push     af
         call     nc,&go_left
         pop      af
         rrca
         call     nc,&go_right

         ld       a,(p)                      ; Draw paddle
         srl      a
         ld       d,a
         ld       e,52
         ld       ix,&paddlen
         ld       a,(expand)
         or       a
         jr       z,nw111
         ld       ix,&paddlew
nw111:
         jp       &drw_sprw

go_right:
         ld       a,(expand)
         neg
         add      a,224
         ld       d,a
         ld       a,(p)
         cp       d
         jr       z,right_edge
         inc      a
         ld       c,1
         in       e,(c)
         bit      3,e
         jr       z,quit_moving

         ld       b,4
lr:
         cp       d
         jr       z,right_edge
         inc      a
         djnz     lr

quit_moving:
         jr       edgecommon
right_edge:                                  ;If paddle is at right edge
         ld       a,d
edgecommon:
         ld       (p),a
         ret
go_left:
         ld       a,(p)
         cp       0
         jr       z,left_edge

         dec      a
         jr       z,left_edge

         ld       c,1
         in       e,(c)
         bit      3,e
         jr       z,quit_moving

         ld       b,4
ll:
         dec      a
         jr       z,left_edge
         djnz     ll

         ld       (p),a
         xor      a
         ret
left_edge:                                   ;If paddle is at left edge
         xor      a
         jr       edgecommon

 ; ************** Draw the background *************************************

draw_level:
         ld       hl,GRAPH_MEM
         ld       b,110
         xor      a
clgloop: ld       (hl),a
         inc      hl
         ld       (hl),a
         inc      hl
         ld       (hl),a
         inc      hl
         ld       (hl),a
         inc      hl
         ld       (hl),a
         inc      hl
         ld       (hl),a
         inc      hl
         ld       (hl),a
         inc      hl
         ld       (hl),a
         inc      hl
         djnz     clgloop
         ld       a,(guard)
         ld       b,16
dbloop:  ld       (hl),a
         inc      hl
         djnz     dbloop
                                             
         ld       hl,won                     ;Redraw all bricks
         ld       (hl),0
         ld       ix,GRAPH_MEM
         ld       hl,data
         ld       b,8
rs_outer:push     bc
         ld       b,16
rs_inner:ld       a,(hl)
         dec      a
         jr       z,draw_block
         dec      a
         JR       Z,draw_block_tough
         dec      a
         jr       z,draw_block_solid
ok:      inc      hl
         inc      ix
         djnz     rs_inner
         ld       de,48
         add      ix,de
         pop      bc
         djnz     rs_outer
         ret
draw_block:                                  ;Draw a standard block
         cpl
         ld       (won),a
         ld       (ix+0),255
         ld       (ix+16),129
         ld       (ix+32),129
         ld       (ix+48),255
         jr       ok
draw_block_solid:                            ;Draw a solid block
         ld       (ix+0),255
         ld       (ix+16),255
         ld       (ix+32),255
         ld       (ix+48),255
         jr       ok
draw_block_tough:                            ;Draw a tough block
         cpl
         ld       (won),a
         ld       (ix+0),255
         ld       (ix+16),195
         ld       (ix+32),195
         ld       (ix+48),255
         jr       ok

 ; ************** Sprite Drawing Routine **********************************

drw_spr:
         call     &pixoffset
         ld       (&smc1+1),a
         call     &pixaddr
         ld       d,(ix)       
         ld       b,(ix+1)        
oloop:   push     bc                         ;Save # of rows
         push     hl                         ;Save screen address
         ld       b,d                        ;Load width
         ld       c,(ix+2)                   ;Load one line of image
         inc      ix
smc1     ld       a,1                        ;Load pixel mask
iloop:   sla      c                          ;Test leftmost pixel
         jr       nc,noplot                  ;See if a plot is needed
         ld       e,a                        ;OR pixel with screen
         or       (hl)
         ld       (hl),a
         ld       a,e
noplot:  rrca
         jr       nc,notedge                 ;Test if edge of byte reached
         inc      hl                         ;Go to next byte
notedge: djnz     iloop
         pop      hl                         ;Restore address
         ld       bc,16                      ;Go to next line
         add      hl,bc
         pop      bc                         ;Restore data
         djnz     oloop
         ret

drw_sprw:
         call     &pixoffset
         ld       (&wsmc1+1),a
         ld       (&wsmc2+1),a
         call     &pixaddr          
         ld       d,(ix)       
         ld       b,(ix+1)        
woloop:  push     bc                         ;Save # of rows
         push     hl                         ;Save screen address
         ld       b,d                        ;Load width
         ld       c,(ix+2)                   ;Load one line of image
         inc      ix
wsmc1    ld       a,1                        ;Load pixel mask
wiloop:  sla      c                          ;Test leftmost pixel
         jr       nc,wnoplot                 ;See if a plot is needed
         ld       e,a                        ;OR pixel with screen
         or       (hl)
         ld       (hl),a
         ld       a,e
wnoplot: rrca
         jr       nc,wnotedge                ;Test if edge of byte reached
         inc      hl                         ;Go to next byte
wnotedge
wsmc2:   cp       1
         jr       z,wover_1
         djnz     wiloop
         pop      hl                         ;Restore address
         ld       bc,16                      ;Go to next line
         add      hl,bc
         pop      bc                         ;Restore data
         djnz     woloop
         ret
wover_1: ld       c,(ix+2)
         inc      ix
         djnz     wiloop
         dec      ix
         pop      hl
         ld       bc,16
         add      hl,bc
         pop      bc
         djnz     woloop
         ret

offsets_table:
         .db      128,64,32,16,8,4,2,1

pixoffset:
         ld       a,d
         and      7
         ld       hl,&offsets_table
         ld       c,a
         ld       b,0
         add      hl,bc
         ld       a,(hl)
         ret

pixaddr: ld       hl,GRAPH_MEM               ;Calculate byte number
         ld       a,e
         add      a,a
         add      a,a
         add      a,a
         rl       b
         add      a,a
         rl       b
         ld       c,d
         srl      c
         srl      c
         srl      c
         or       c
         ld       c,a
         add      hl,bc
         ret
                            
 ; ************** Sprite For Paddle ***************************************

paddlen: .db      16,4
         .db      %01111111,%11111110
         .db      %10000000,%00000001
         .db      %10000000,%00000001
         .db      %01111111,%11111110
paddlew: .db      32,4
         .db      %01111111,%11111111,%11111111,%11111110
         .db      %10000000,%00000000,%00000000,%00000001
         .db      %10000000,%00000000,%00000000,%00000001
         .db      %01111111,%11111111,%11111111,%11111110

spr_ball:.db      3,3
         .db      %01000000
         .db      %11100000
         .db      %01000000

 ; ************** Process A Ball ******************************************

release: ld       (hl),50
         inc      hl
         ld       (hl),-1
         dec      hl
         dec      hl
         dec      hl
         ld       a,(p)
         add      a,(hl)
         ld       (hl),a
         jp       &ballstuff

coughtit:
         dec      (hl)
         pop      hl                         ;HL -> Y
         inc      hl
         ld       (hl),55
         dec      hl
         dec      hl
         dec      hl                         ;HL -> X
         ld       a,(p)
         sub      (hl)
         neg
         ld       (hl),a
         inc      hl
         inc      hl

caught_ball:                                 ;HL -> Y
         ld       a,%00111111
         out      (1),a
         ld       e,51
         in       a,(1)
         bit      5,a
         jr       z,release
         ld       a,(p)
         dec      hl
         dec      hl
         add      a,(hl)
         srl      a
         Dec      a
         ld       d,a
         dec      a
         ld       ix,&spr_ball
         jp       &drw_spr

paddle:
         push     hl
         dec      hl
         dec      hl
         ld       a,(hl)                     ;HL -> X
         ld       hl,p
         sub      (hl)
         pop      hl                         ;HL -> Y
         jp       m,&doneyb
         srl      a
exp2:    nop
         nop
         ld       e,a
         and      240
         jp       nz,&doneyb
         push     hl
         inc      hl                         ;HL -> YV
         ld       (hl),-1

         ld       d,0
         ld       hl,&bounces
         add      hl,de
         ld       a,(hl)
         pop      hl
         push     hl                
         dec      hl                         ;HL -> XV
         ld       (hl),a
         ld       a,5
         ld       (incr),a
         ld       hl,bthru
         ld       a,(hl)
         or       a
         jr       z,ndbt
         dec      a
         ld       (hl),a
ndbt:

         ld       hl,catch
         ld       a,(hl)
         or       a
         jr       nz,coughtit
         pop      hl

         jr       doneyb

top:     inc      hl
         ld       (hl),1
         dec      hl
         jr       doneyb

bottom:  ld       a,(guard)
         or       a
         jr       nz,guarded
         inc      hl
         ld       (hl),0
         ret
guarded: inc      hl
         ld       (hl),-1
         dec      hl
         rrca
         ld       a,%10101010
         ld       (guard),a
         jr       c,doneyb
         xor      a
         ld       (guard),a
         jr       doneyb

ballstuff:
         inc      hl
         inc      hl
         inc      hl                         ;HL -> YV
         ld       a,(hl)

         or       a
         ret      z
         ld       (aball),a
         cp       55
         dec      hl                         ;HL -> Y

         jp       z,&caught_ball
         add      a,(hl)
         ld       (hl),a
         dec      a
         jr       z,top
         cp       50
         jr       z,paddle
         cp       51

         jr       z,paddle
         cp       52
         jr       z,paddle
         cp       53
         jr       z,bottom
doneyb:                                      ;HL -> Y
         push     hl
         call     __test_hit
         pop      hl
         jr       nc,nohit1
         ld       a,(bthru)
         or       a
         jr       nz,nohit1
         inc      hl
         ld       a,(hl)
         neg
         ld       (hl),a
         dec      hl
         add      a,(hl)
         ld       (hl),a                     ;HL -> Y

nohit1:  dec      hl                         ;Bounce off left/right sides
         dec      hl
         ld       a,(hl)
         inc      hl
         rrca
         rrca
         and      63
         jr       z,forceright
         cp       63
         jr       z,forceleft
dodraw:  ld       a,(hl)                     ;Move ball horizontally
         ;sra      a
         ;jr       nc,exact
         ;push     hl
         ;ld       hl,timer
         ;bit      0,(hl)
         ;pop      hl
         ;jr       z,exact
         ;inc      a
exact:   dec      hl
         add      a,(hl)
         ld       (hl),a

         push     hl
         inc      hl
         inc      hl
         call     __test_hit
         pop      hl
	 
         jr       nc,nohit2
         ld       a,(bthru)
         or       a
         jr       nz,nohit2
         inc      hl
         ld       a,(hl)
         neg
         ld       (hl),a
         dec      hl
         add      a,(hl)
         ld       (hl),a
nohit2:
         ld       d,(hl)
         inc      hl
         inc      hl                      
         srl      d
         dec      d
         ld       e,(hl)
         dec      e

         ld       ix,&spr_ball
         jp       &drw_spr

forceright:                                  ;Make ball go right
         ld       a,(hl)
         neg
         jp       m,&dodraw
fcommon: ld       (hl),a
         jr       dodraw
forceleft:                                   ;Make ball go left
         ld       a,(hl)
         neg
         jp       p,&dodraw
         jr       fcommon

 ; ************** Test If The Ball Hits A Brick ***************************

test_hit:
         ld       a,(hl)
         ld       e,a
         bit      5,a
         jr       nz,bottom_half             ;Can't hit anything if below 32
         and      28                         ;A = row * 4
         add      a,a
         add      a,a                        
         ld       b,a                        ;B = row * 16
         dec      hl
         dec      hl
         ld       a,(hl)                     ;A = X coord
         and      240                        ;A = column
         ld       d,a
         rrca
         rrca
         rrca
         rrca                               
         and      15                         ;A = column / 16
         or       b                          ;A = column / 16 + row * 4
         ld       l,a
         ld       h,$81
         ld       a,(hl)                     ;A = brick type
         dec      a
         jr       z,hit_1
         dec      a
         jr       z,hit_2
         dec      a
         jr       z,hit_3
bottom_half:
         scf
         ccf
         ret

hit_1:   ld       (hl),a
         ld       hl,(score)
         ld       a,(incr)
         inc      a
         ld       (incr),a
         ld       c,a
         ld       b,0
         add      hl,bc
         ld       (score),hl

         ld       hl,bonust
         ld       a,(hl)
         or       a
         scf
         ret      nz

         ld       a,r
         rrca
         ret      c
         and      3
         inc      a

         ld       b,a
         ld       a,d
         rla
         jr       c,abcdef
         ld       (hl),b
         inc      hl
         ld       (hl),d

         jr       common71

abcdef:  inc      b
         inc      b
         inc      b
         ld       (hl),b
         inc      hl
         ld       a,d
         sub      8
         ld       (hl),a
common71:inc      hl
         ld       (hl),e

         dec      hl
         dec      hl
         scf
         ret     

hit_2:   ld       (hl),1
         ld       hl,(score)
         inc      hl
         ld       (score),hl
hit_3:   scf
         ret

 ; ******************* Orzunoid Data Block (for universes) ****************

orz_data:
         .db      6                          ; Orzunoid major version
         .db      1                          ; Orzunoid minor version
         jp       &title_screen
         jp       &start_game
         jp       &play_level
         jp       &extract_level
         jp       &ballstuff
         jp       &test_hit
         jp       &draw_level
         .db      10
         jp       &bonus_blocks
         jp       &bonus_get_image
         jp       &bonus_collect
         jp       &paddle_move
         jp       &init_display
         jp       &update_display
         jp       &display_screen
         jp       &exit_game
         jp       &prepare_level
         jp       &level_win
         jp       &game_win
         jp       &resume_game

 ; ************** Bounce Data *********************************************

bounces:
         .db      -3,-2,-2,-2,-1,-1,-1,0
         .db      0,1,1,1,2,2,2,3

 ; ************** Default Messages ****************************************

ingame:  .db      "Lives:  0 Score:",0

title_message:
         .db      "Orzunoid v6.4    "
         .db      " Copyright 1997-1999 "
         .db      " by Patrick Davidson ",0

contact_messages:
         .db      "luezma@netscape.net",0
         .db      "http://surf.to/eeulplek/",0
                  

title_screen_inst:
         .db      "Instructions:",0
instructions_text:
         .db      "Press [ALPHA] to view "
         .db      "the high scores ",0
         .db      "Use [F1]-[F5] to "
         .db      "select speed & begin",0
         .db      "Left & right arrows "
         .db      "move the paddle",0
         .db      "Hold the up arrow "
         .db      "to move slowly",0
         .db      "Use the down arrow "
         .db      "to save the game",0
         .db      "[CLEAR] gives up one life, "
         .db      "[EXIT] quits",0

paused_msg:
         .db      "Paused - "
enter_message:
         .db      "Press [ENTER] to play",0
         .db      "Press [+] or [-] "
         .db      "to change contrast",0

saved_message:
         .db      "There is a saved game"
         .db      "F1) Restore the game "
         .db      "F5) Start a new game",0

restore_error:
         .db      "Restore Error!",0

 ; ************** Saved Game Data *****************************************

saved_flag:
         .db      0
___TEXT_MEM:
         .dw      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         .dw      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         .dw      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         .dw      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
___DELC_MEM:
         .dw      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0    
         .dw      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
universe_id:
         .dw      0,0,0,0,0
save_end:

 ; ******************** Universe Data *************************************

universe:
         .db      %11111100,%00000000,%00000000,%00111111
         .db      %11110000,%00000000,%00000000,%00001111
         .db      %11000000,%00000000,%00000000,%00000011
         .db      %00000000,%00000000,%00000000,%00000000
         .db      %00000000,%10101010,%10101010,%00000000
         .db      %00000000,%01010101,%01010101,%00000000
         .db      %00000000,%00000000,%00000000,%00000000
         .db      %00000000,%00000000,%00000000,%00000000

         .db      %01010101,%01010101,%01010101,%01010101
         .db      %01000000,%00000000,%00000000,%00000001
         .db      %01000001,%00010001,%00010001,%00010001
         .db      %01000100,%01000100,%01000100,%01000001
         .db      %01000000,%00000000,%00000000,%00000001
         .db      %01000101,%01010101,%01010101,%01010001
         .db      %01000000,%00000000,%00000000,%00000001
         .db      %01001111,%11111100,%00111111,%11110001

         .db      %11000000,%00000000,%00000000,%00000011
         .db      %11010101,%01010101,%01010101,%01010111
         .db      %11000000,%00000000,%00000000,%00000011
         .db      %11010101,%01010101,%01010101,%01010111
         .db      %11000000,%00000000,%00000000,%00000011
         .db      %11010101,%01010101,%01010101,%01010111
         .db      %11000000,%00000000,%00000000,%00000011
         .db      %11000000,%00000000,%00000000,%00000011

         .db      %01000100,%01000100,%01000100,%01000100
         .db      %00010001,%00010001,%00010001,%00010001
         .db      %01000100,%01000100,%01000100,%01000100
         .db      %00010001,%00010001,%00010001,%00010001
         .db      %01000100,%01000100,%01000100,%01000100
         .db      %00010001,%00010001,%00010001,%00010001
         .db      %00000000,%00000000,%00000000,%00000000
         .db      %11111100,%00000000,%00000000,%00111111

         .db      %00000000,%00000000,%00000000,%00000000
         .db      %00001111,%11111111,%11111111,%11110000
         .db      %00000000,%00000000,%00000000,%00000000
         .db      %00000001,%01010101,%01010101,%01000000
         .db      %00000001,%01010101,%01010101,%01000000
         .db      %00000001,%01010101,%01010101,%01000000
         .db      %00000000,%00000000,%00000000,%00000000
         .db      %00001111,%11111111,%11111111,%11110000

         .DB      %00000000,%00000000,%00000000,%00000000                                          
         .DB      %00000000,%00000000,%00000000,%00000000                                          
         .DB      %10101010,%10101010,%10101010,%10101010                                          
         .DB      %01010101,%01010101,%01010101,%01010101                                         
         .DB      %01010101,%01010101,%01010101,%01010101                                         
         .DB      %01010101,%01010101,%01010101,%01010101                                         
         .DB      %01010101,%01010101,%01010101,%01010101                                         
         .DB      %00000000,%00000000,%00000000,%00000000

         .db      %00000000,%00000000,%00000000,%00000000
         .db      %00000000,%00000000,%00000000,%00000000
         .db      %00001101,%01010101,%01010101,%01110000
         .db      %00001101,%01010101,%01010101,%01110000
         .db      %00001101,%01010101,%01010101,%01110000
         .db      %00000000,%00000000,%00000000,%00000000
         .db      %00000000,%00000000,%00000000,%00000000
         .db      %00001111,%11111111,%11111111,%11110000

         .db      %00000000,%00000000,%00000000,%00000000
         .db      %00101000,%10101000,%10101000,%10101000
         .db      %00101000,%10001000,%10001000,%10001000
         .db      %00101000,%10101000,%10101000,%10101000
         .db      %00101000,%00001000,%00001000,%10001000
         .db      %00101000,%10101000,%10101000,%10101000
         .db      %00000000,%00000000,%00000000,%00000000
         .db      %11111111,%00000000,%00000000,%11111111

         .db      %10101010,%00000101,%10000010,%10101000
         .db      %10000000,%10001000,%00100010,%00000010
         .db      %10000000,%10001000,%00100010,%00000010
         .db      %10000000,%10001000,%00100010,%00000010
         .db      %10101010,%00001010,%10100010,%00000010
         .db      %10000000,%00001000,%00100010,%00000010
         .db      %10000000,%00001000,%00100010,%00000010
         .db      %10000000,%00001000,%00100010,%10101000

         .db      %00000000,%01010101,%01010101,%00000000
         .db      %00000001,%11111101,%01111111,%01000000
         .db      %00000001,%11111101,%01111111,%01000000
         .db      %00000001,%01010101,%01010101,%01000000
         .db      %00000001,%01010101,%01010101,%01000000
         .db      %00000001,%11111101,%01111111,%01000000
         .db      %00000001,%11111101,%01111111,%01000000
         .db      %00000000,%01010101,%01010101,%00000000

 ; ********************** Bonus Blocks ************************************

bonus_1: .db      11,3
         .db      %01111111,%11000000
         .DB      %10000000,%00100000
         .db      %01111111,%11000000
bonus_2: .db      11,3
         .db      %01000100,%01000000
         .db      %11101110,%11100000
         .db      %01000100,%01000000
bonus_3: .db      12,5
         .db      %00100000,%01000000
         .db      %01000000,%00100000
         .db      %11111111,%11110000
         .db      %01000000,%00100000
         .db      %00100000,%01000000
bonus_4: .db      11,5
         .db      %10011000,%11000000
         .db      %10100101,%00100000
         .db      %10100101,%00100000
         .db      %10100101,%00100000
         .db      %10011000,%11000000
bonus_5: .db      12,2
         .db      %11111111,%11110000
         .db      %11111111,%11110000
bonus_6: .db      12,4
         .db      %10000000,%00010000
         .db      %10000000,%00010000
         .db      %11111111,%11110000
         .db      %10000000,%00010000
bonus_7: .db      12,5
         .db      %00100000,%00000000
         .db      %01000000,%10000000
         .db      %11111111,%11110000
         .db      %01000000,%10000000
         .db      %00100000,%00000000

 ; ******************** High Scores ***************************************

hi_score_str:
         .db      "****> ORZUNOID! <****"
         .db      "  You have a hiscore!"
         .db      "Enter your name:     ",0
hstitle: .db      "=Orzunoid Highscores=",0
hsdata:  .dw      12500
         .db      "Orzunoid 6.4    ",0
         .dw      10000
         .db      "Orzunoid 6.4    ",0
         .dw      8000
         .db      "Orzunoid 6.4    ",0
         .dw      6000
         .db      "Orzunoid 6.4    ",0
         .dw      4000
         .db      "Orzunoid 6.4    ",0
         .dw      3000
         .db      "Orzunoid 6.4    ",0
lowest   .dw      2000
         .db      "Orzunoid 6.4    ",0
chartable:
         .db      "XTOJE."
         .db      ". WSNID!.ZVRMHC?"
         .db      ".YUQLGB#x~+PKFA|"
         .db      "@54321.~+"

         .end
